/*
	Additional objects - D. Aust

*/

CREATE OR REPLACE VIEW oehr_orders_v
AS
   SELECT ord.order_id,
          ord.order_date,
          ord.order_mode,
          ord.ORDER_STATUS,
          CASE ORD.ORDER_STATUS
             WHEN 0 THEN 'Not fully entered'
             WHEN 1 THEN 'Entered'
             WHEN 2 THEN 'Canceled - bad credit'
             WHEN 3 THEN 'Canceled - by customer'
             WHEN 4 THEN 'Shipped - whole order'
             WHEN 5 THEN 'Shipped - replacement items'
             WHEN 6 THEN 'Shipped - backlog on items'
             WHEN 7 THEN 'Shipped - special delivery'
             WHEN 8 THEN 'Shipped - billed'
             WHEN 9 THEN 'Shipped - payment plan'
             WHEN 10 THEN 'Shipped - paid'
             ELSE to_char(ord.order_status)
          END
             order_status_text,
          ord.order_total,
          ord.customer_id,
          cust.CUST_FIRST_NAME,
          cust.cust_last_name,
          cust.city cust_city,
          (select count(*) from oehr_order_items where order_id=ord.order_id) cnt_order_items
     FROM oehr_orders ord INNER JOIN oehr_customers cust ON (cust.customer_id = ord.customer_id);


CREATE OR REPLACE VIEW oehr_order_items_v
AS
   SELECT ord.*,
          OIT.ORDER_ITEM_ID,
          OIT.LINE_ITEM_ID,
          OIT.QUANTITY,
          OIT.UNIT_PRICE,
          PRD.PRODUCT_ID,
          PRD.PRODUCT_NAME,
          PRD.PRODUCT_STATUS
     FROM oehr_orders_v ord
          INNER JOIN oehr_order_items oit
             ON (oit.order_id = ord.order_id)
          INNER JOIN oehr_product_information prd
             ON (prd.product_id = OIT.PRODUCT_ID);

