SET DEFINE OFF;

prompt OM_BP_ADR_TYPES
CREATE TABLE  "OM_BP_ADR_TYPES" 
   (    "ADRT_CODE" VARCHAR2(50) NOT NULL ENABLE, 
    "ADRT_TITLE" VARCHAR2(100), 
    "ADRT_DESC" VARCHAR2(4000), 
    "ADRT_CREATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "ADRT_CREATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "ADRT_UPDATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "ADRT_UPDATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "ADRT_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_BP_ADR_TYPES_PK" PRIMARY KEY ("ADRT_CODE") ENABLE
   )
/

prompt om_business_partners
CREATE TABLE  "OM_BUSINESS_PARTNERS" 
   (    "BP_ID" NUMBER NOT NULL ENABLE, 
    "BP_TITLE" VARCHAR2(100) NOT NULL ENABLE, 
    "BP_SAP_NO" VARCHAR2(20), 
    "BP_IS_CUSTOMER" NUMBER DEFAULT 0 NOT NULL ENABLE, 
    "BP_IS_SUPPLIER" NUMBER DEFAULT 0 NOT NULL ENABLE, 
    "BP_IS_OWNER" NUMBER DEFAULT 0 NOT NULL ENABLE, 
    "BP_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "BP_CREATED_ON" DATE NOT NULL ENABLE, 
    "BP_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "BP_UPDATED_ON" DATE NOT NULL ENABLE, 
    "BP_UPDATED_DESC" VARCHAR2(4000), 
    "BP_DESC" VARCHAR2(4000), 
    "BP_VALID_FROM" DATE, 
    "BP_VALID_UNTIL" DATE, 
     CONSTRAINT "OM_BUSINESS_PARTNERS_CHK1" CHECK (BP_IS_CUSTOMER IN (0, 1)) ENABLE, 
     CONSTRAINT "OM_BUSINESS_PARTNERS_CHK2" CHECK (BP_IS_SUPPLIER IN (0, 1)) ENABLE, 
     CONSTRAINT "OM_BUSINESS_PARTNERS_CHK3" CHECK (BP_IS_OWNER IN (0, 1)) ENABLE, 
     CONSTRAINT "OM_CUSTOMERS_PK" PRIMARY KEY ("BP_ID") ENABLE, 
     CONSTRAINT "OM_BUSINESS_PARTNERS_UK1" UNIQUE ("BP_TITLE") ENABLE
   )
/

prompt om_bp_addresses
CREATE TABLE  "OM_BP_ADDRESSES" 
   (    "ADR_ID" NUMBER NOT NULL ENABLE, 
    "ADR_ADRT_CODE" VARCHAR2(50) DEFAULT 'DEFAULT' NOT NULL ENABLE, 
    "ADR_ZIP_CODE" VARCHAR2(20), 
    "ADR_STREET" VARCHAR2(50), 
    "ADR_STREET_NO" VARCHAR2(10), 
    "ADR_CITY" VARCHAR2(50), 
    "ADR_COUNTRY_CODE" VARCHAR2(50), 
    "ADR_BP_ID" NUMBER NOT NULL ENABLE, 
    "ADR_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "ADR_CREATED_ON" DATE NOT NULL ENABLE, 
    "ADR_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "ADR_UPDATED_ON" DATE NOT NULL ENABLE, 
    "ADR_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_CUST_ADDRESSES_PK" PRIMARY KEY ("ADR_ID") ENABLE
   )
/

prompt 
CREATE TABLE  "OM_BP_COD_TYPES" 
   (    "CODT_CODE" VARCHAR2(50) NOT NULL ENABLE, 
    "CODT_TITLE" VARCHAR2(100), 
    "CODT_VALID_FROM" DATE, 
    "CODT_VALID_UNTIL" DATE, 
    "CODT_DESC" VARCHAR2(4000), 
    "CODT_SEQ" NUMBER, 
    "CODT_IS_BUSINESS" NUMBER(1,0) DEFAULT 0 NOT NULL ENABLE, 
    "CODT_IS_PRIVATE" NUMBER(1,0) DEFAULT 0 NOT NULL ENABLE, 
    "CODT_CREATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "CODT_CREATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "CODT_UPDATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "CODT_UPDATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "CODT_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_BP_COD_TYPES_C01" CHECK (CODT_IS_BUSINESS in (0,1)) ENABLE, 
     CONSTRAINT "OM_BP_COD_TYPES_C02" CHECK (CODT_IS_PRIVATE in (0,1)) ENABLE, 
     CONSTRAINT "OM_BP_COD_TYPES_PK" PRIMARY KEY ("CODT_CODE") ENABLE
   )
/

CREATE TABLE  "OM_BP_CONTACTS" 
   (    "CON_ID" NUMBER NOT NULL ENABLE, 
    "CON_BP_ID" NUMBER NOT NULL ENABLE, 
    "CON_SEQ" NUMBER, 
    "CON_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "CON_CREATED_ON" DATE NOT NULL ENABLE, 
    "CON_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "CON_UPDATED_ON" DATE NOT NULL ENABLE, 
    "CON_UPDATED_DESC" VARCHAR2(4000), 
    "CON_GENDER_CODE" VARCHAR2(50) NOT NULL ENABLE, 
    "CON_FIRST_NAME" VARCHAR2(50), 
    "CON_LAST_NAME" VARCHAR2(50), 
    "CON_DESCRIPTION" VARCHAR2(4000), 
    "CON_TITLE" VARCHAR2(100), 
     CONSTRAINT "OM_BP_CONTACTS_CHK1" CHECK (CON_GENDER_CODE IN ('MALE', 'FEMALE', 'NON-PERSON')) ENABLE, 
     CONSTRAINT "OM_BP_CONTACTS_PK" PRIMARY KEY ("CON_ID") ENABLE
   )
/

CREATE TABLE  "OM_BP_CON_DETAILS" 
   (    "COD_ID" NUMBER NOT NULL ENABLE, 
    "COD_CON_ID" NUMBER NOT NULL ENABLE, 
    "COD_CODT_CODE" VARCHAR2(20), 
    "COD_VALUE" VARCHAR2(100), 
    "COD_CREATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "COD_CREATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "COD_UPDATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "COD_UPDATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "COD_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_BP_CON_DETAILS_PK" PRIMARY KEY ("COD_ID") ENABLE
   )
/

CREATE TABLE  "OM_ORDERS" 
   (    "ORD_ID" NUMBER NOT NULL ENABLE, 
    "ORD_SUPPLIER_BP_ID" NUMBER NOT NULL ENABLE, 
    "ORD_CUSTOMER_BP_ID" NUMBER NOT NULL ENABLE, 
    "ORD_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "ORD_CREATED_ON" DATE NOT NULL ENABLE, 
    "ORD_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "ORD_UPDATED_ON" DATE NOT NULL ENABLE, 
    "ORD_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_ORDERS_PK" PRIMARY KEY ("ORD_ID") ENABLE
   )
/

CREATE TABLE  "OM_ORD_ITEMS" 
   (    "OIT_ID" NUMBER NOT NULL ENABLE, 
    "OIT_ORD_ID" NUMBER NOT NULL ENABLE, 
    "OIT_PROD_ID" NUMBER NOT NULL ENABLE, 
    "OIT_SEQ" VARCHAR2(20), 
    "OIT_QUANTITY" NUMBER, 
    "OIT_PRICE" NUMBER, 
    "OIT_DISCOUNT_PERCENT" NUMBER, 
    "OIT_DISCOUNT_VALUE" NUMBER, 
    "OIT_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "OIT_CREATED_ON" DATE NOT NULL ENABLE, 
    "OIT_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "OIT_UPDATED_ON" DATE NOT NULL ENABLE, 
    "OIT_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_ORD_ITEMS_PK" PRIMARY KEY ("OIT_ID") ENABLE
   )
/

CREATE TABLE  "OM_PROD_TYPES" 
   (    "PT_CODE" VARCHAR2(50) NOT NULL ENABLE, 
    "PT_TITLE" VARCHAR2(100), 
    "PT_DESC" VARCHAR2(4000), 
    "PT_VALID_FROM" DATE, 
    "PT_VALID_UNTIL" DATE, 
    "PT_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PT_CREATED_ON" DATE NOT NULL ENABLE, 
    "PT_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PT_UPDATED_ON" DATE NOT NULL ENABLE, 
    "PT_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_PRODUCT_TYPES_PK" PRIMARY KEY ("PT_CODE") ENABLE
   )
/

CREATE TABLE  "XLIB_CMS_FILES" 
   (    "FIL_ID" NUMBER NOT NULL ENABLE, 
    "FIL_CREATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "FIL_CREATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "FIL_UPDATED_BY" VARCHAR2(50) DEFAULT user NOT NULL ENABLE, 
    "FIL_UPDATED_ON" DATE DEFAULT sysdate NOT NULL ENABLE, 
    "FIL_UPDATED_DESC" VARCHAR2(4000), 
    "FIL_NAME" VARCHAR2(4000 CHAR), 
    "FIL_DESCRIPTION" VARCHAR2(4000 CHAR), 
    "FIL_BLOB_CONTENT" BLOB, 
    "FIL_MIME_TYPE" VARCHAR2(4000 CHAR), 
    "FIL_TITLE" VARCHAR2(255 CHAR), 
     CONSTRAINT "XLIB_CMS_FILES_PK" PRIMARY KEY ("FIL_ID") ENABLE
   )
/

CREATE TABLE  "OM_PRODUCTS" 
   (    "PROD_ID" NUMBER NOT NULL ENABLE, 
    "PROD_PT_CODE" VARCHAR2(50) NOT NULL ENABLE, 
    "PROD_PCAT_ID_PARENT" NUMBER, 
    "PROD_PCAT_ID" NUMBER NOT NULL ENABLE, 
    "PROD_TITLE" VARCHAR2(100), 
    "PROD_IMAGE_FIL_ID" NUMBER, 
    "PROD_VALID" VARCHAR2(1) DEFAULT 'Y', 
    "PROD_RANK" NUMBER, 
    "PROD_DISCOUNT_PERCENT" NUMBER, 
    "PROD_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PROD_CREATED_ON" DATE NOT NULL ENABLE, 
    "PROD_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PROD_UPDATED_ON" DATE NOT NULL ENABLE, 
    "PROD_UPDATED_DESC" VARCHAR2(4000), 
     CONSTRAINT "OM_PRODUCTS_PK" PRIMARY KEY ("PROD_ID") ENABLE
   )
/

CREATE TABLE  "OM_PROD_CATEGORIES" 
   (    "PCAT_ID" NUMBER NOT NULL ENABLE, 
    "PCAT_CODE" VARCHAR2(50) NOT NULL ENABLE, 
    "PCAT_TITLE" VARCHAR2(100), 
    "PCAT_PARENT_ID" NUMBER, 
    "PCAT_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PCAT_CREATED_ON" DATE NOT NULL ENABLE, 
    "PCAT_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PCAT_UPDATED_ON" DATE NOT NULL ENABLE, 
    "PCAT_UPDATED_DESC" VARCHAR2(4000), 
    "PCAT_PT_CODE" VARCHAR2(50), 
     CONSTRAINT "OM_PRODUCT_CATEGORIES_PK" PRIMARY KEY ("PCAT_ID") ENABLE
   )
/

CREATE TABLE  "OM_PROD_PRICES" 
   (    "PRI_ID" NUMBER NOT NULL ENABLE, 
    "PRI_PROD_ID" NUMBER NOT NULL ENABLE, 
    "PRI_CREATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PRI_CREATED_ON" DATE NOT NULL ENABLE, 
    "PRI_UPDATED_BY" VARCHAR2(50) NOT NULL ENABLE, 
    "PRI_UPDATED_ON" DATE NOT NULL ENABLE, 
    "PRI_UPDATED_DESC" VARCHAR2(4000), 
    "PRI_VALID_FROM" DATE, 
    "PRI_VALID_UNTIL" DATE, 
    "PRI_PRICE" NUMBER, 
     CONSTRAINT "OM_PRICES_PK" PRIMARY KEY ("PRI_ID") ENABLE
   )
/

CREATE TABLE  "OM_SALES_CAMPAIGN" 
   (    "SCAM_ID" NUMBER, 
    "SCAM_PCAT_ID" NUMBER NOT NULL ENABLE, 
    "SCAM_START_DATE" DATE, 
    "SCAM_END_DATE" DATE, 
    "SCAM_SALES_CAMPAIGN_FROM" DATE, 
    "SCAM_SALES_CAMPAIGN_TO" DATE, 
    "SCAM_STATUS" NUMBER
   )
/

CREATE TABLE  "OM_SALES_PER_REGION" 
   (    "SPR_ID" NUMBER NOT NULL ENABLE, 
    "SPR_STATE_NAME" VARCHAR2(100), 
    "SPR_STATE_CODE" VARCHAR2(2), 
    "SPR_SALES_TOTAL" NUMBER, 
    "SPR_REGION" NUMBER
   )
/

CREATE TABLE  "XLIB_COMPONENTS" 
   (    "COMP_ID" NUMBER, 
    "COMP_NAME" VARCHAR2(100 CHAR), 
    "COMP_VERSION" VARCHAR2(50 CHAR), 
    "COMP_VERSION_LABEL" VARCHAR2(50 CHAR), 
    "COMP_DEPENDS_ON" VARCHAR2(4000 CHAR), 
     CONSTRAINT "XLIB_COMPONENTS_PK" PRIMARY KEY ("COMP_ID") ENABLE, 
     CONSTRAINT "XLIB_COMPONENTS_U01" UNIQUE ("COMP_NAME") ENABLE
   )
/

CREATE TABLE  "XLIB_CONF_VALUES" 
   (    "CONF_ID" NUMBER, 
    "CONF_APP_CTX" VARCHAR2(50) DEFAULT 'GLOBAL', 
    "CONF_DOMAIN" VARCHAR2(50) DEFAULT 'GLOBAL', 
    "CONF_KEY" VARCHAR2(100 CHAR), 
    "CONF_VALUE" VARCHAR2(4000 CHAR), 
    "CONF_COMMENT" VARCHAR2(4000 CHAR)
   )
/

CREATE TABLE  "XLIB_LOGS" 
   (    "LOG_ID" NUMBER, 
    "LOG_MODULE" VARCHAR2(100 CHAR), 
    "LOG_MSG" VARCHAR2(4000 CHAR), 
    "LOG_TYPE" VARCHAR2(20 CHAR) DEFAULT 'DEBUG', 
    "LOG_LEVEL" NUMBER DEFAULT 15, 
    "LOG_CREATED_ON" DATE, 
    "LOG_CREATED_BY" VARCHAR2(30 CHAR), 
     CONSTRAINT "XLIB_LOGS_PK" PRIMARY KEY ("LOG_ID") ENABLE
   )
/

ALTER TABLE  "OM_BP_ADDRESSES" ADD CONSTRAINT "OM_BP_ADDRESSES_OM_BP_ADR_FK1" FOREIGN KEY ("ADR_ADRT_CODE")
      REFERENCES  "OM_BP_ADR_TYPES" ("ADRT_CODE") ENABLE
/

ALTER TABLE  "OM_BP_CONTACTS" ADD CONSTRAINT "OM_BP_CONTACTS_OM_BUSINES_FK1" FOREIGN KEY ("CON_BP_ID")
      REFERENCES  "OM_BUSINESS_PARTNERS" ("BP_ID") ENABLE
/

ALTER TABLE  "OM_BP_CON_DETAILS" ADD CONSTRAINT "OM_BP_CON_DETAILS_OM_BP_C_FK" FOREIGN KEY ("COD_CODT_CODE")
      REFERENCES  "OM_BP_COD_TYPES" ("CODT_CODE") ENABLE
/

ALTER TABLE  "OM_BP_CON_DETAILS" ADD CONSTRAINT "OM_BP_CON_DETAILS_OM_BP_C_FK1" FOREIGN KEY ("COD_CON_ID")
      REFERENCES  "OM_BP_CONTACTS" ("CON_ID") ENABLE
/

ALTER TABLE  "OM_PROD_CATEGORIES" ADD CONSTRAINT "OM_CATEGORIES_OM_CATEGORI_FK1" FOREIGN KEY ("PCAT_PARENT_ID")
      REFERENCES  "OM_PROD_CATEGORIES" ("PCAT_ID") ENABLE
/

ALTER TABLE  "OM_BP_ADDRESSES" ADD CONSTRAINT "OM_CUST_ADDRESSES_OM_CUST_FK1" FOREIGN KEY ("ADR_BP_ID")
      REFERENCES  "OM_BUSINESS_PARTNERS" ("BP_ID") ENABLE
/

ALTER TABLE  "OM_ORDERS" ADD CONSTRAINT "OM_ORDERS_OM_BUSINESS_PAR_FK1" FOREIGN KEY ("ORD_SUPPLIER_BP_ID")
      REFERENCES  "OM_BUSINESS_PARTNERS" ("BP_ID") ENABLE
/

ALTER TABLE  "OM_ORDERS" ADD CONSTRAINT "OM_ORDERS_OM_BUSINESS_PAR_FK2" FOREIGN KEY ("ORD_CUSTOMER_BP_ID")
      REFERENCES  "OM_BUSINESS_PARTNERS" ("BP_ID") ENABLE
/

ALTER TABLE  "OM_PRODUCTS" ADD CONSTRAINT "OM_PRODUCTS_OM_PROD_TYPES_FK" FOREIGN KEY ("PROD_PT_CODE")
      REFERENCES  "OM_PROD_TYPES" ("PT_CODE") ENABLE
/

ALTER TABLE  "OM_PRODUCTS" ADD CONSTRAINT "OM_PRODUCTS_R03" FOREIGN KEY ("PROD_IMAGE_FIL_ID")
      REFERENCES  "XLIB_CMS_FILES" ("FIL_ID") ENABLE
/

ALTER TABLE  "OM_PROD_CATEGORIES" ADD FOREIGN KEY ("PCAT_PT_CODE")
      REFERENCES  "OM_PROD_TYPES" ("PT_CODE") ENABLE
/

Rem No function found to generate DDL.


 CREATE OR REPLACE PACKAGE  "XLIB_COMPONENT" 
AS
/*=========================================================================
  $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $

  Purpose  :

  License  : Copyright (c) 2010 Dietmar Aust (opal-consulting.de)
             Licensed under a BSD style license (license.txt)
             http://www.opal-consulting.de/pls/apex/f?p=20090928:14

  $LastChangedDate: 2015-05-29 17:08:21 +0200 (Fri, 29 May 2015) $
  $LastChangedBy: dietmar.aust $

  Date        Author          Comment
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  06.01.2010  D. Aust         Initial creation

=========================================================================*/

   -- how many digits does the version key have?
   -- 3 => e.g. 1.0.0
   -- 4 => e.g. 1.0.0.0
   c_num_version_components   CONSTANT NUMBER        := 6;

   PROCEDURE create_component (
      p_name            xlib_components.comp_name%TYPE,
      p_version         xlib_components.comp_version%TYPE,
      p_version_label   xlib_components.comp_version_label%TYPE DEFAULT NULL,
      p_depends_on      xlib_components.comp_depends_on%TYPE DEFAULT NULL
   );

   PROCEDURE set_component (
      p_name            xlib_components.comp_name%TYPE,
      p_version         xlib_components.comp_version%TYPE,
      p_version_label   xlib_components.comp_version_label%TYPE DEFAULT NULL,
      p_depends_on      xlib_components.comp_depends_on%TYPE DEFAULT NULL
   );

   PROCEDURE delete_component (p_name IN xlib_components.comp_name%TYPE);

/*****
utility functions
****/
   FUNCTION get_version (p_name IN xlib_components.comp_name%TYPE)
      RETURN xlib_components.comp_version%TYPE;

   FUNCTION make_version_string (p_version IN VARCHAR2)
      RETURN VARCHAR2;

   PROCEDURE verify_required_component (
      p_comp_name          IN   VARCHAR2,
      p_comp_version_min   IN   VARCHAR2
   );
END xlib_component; 
/
CREATE OR REPLACE PACKAGE BODY  "XLIB_COMPONENT" 
AS
/*=========================================================================
   FILE  :  $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $
=========================================================================*/
   TYPE vc2_arr_t IS TABLE OF VARCHAR2 (32767 CHAR)
      INDEX BY BINARY_INTEGER;

   PROCEDURE create_component (
      p_name            xlib_components.comp_name%TYPE,
      p_version         xlib_components.comp_version%TYPE,
      p_version_label   xlib_components.comp_version_label%TYPE DEFAULT NULL,
      p_depends_on      xlib_components.comp_depends_on%TYPE DEFAULT NULL

   )
   IS
   BEGIN
      INSERT INTO xlib_components
                  (comp_id, comp_name, comp_version, comp_version_label, comp_depends_on
                  )
           VALUES (xlib_seq.NEXTVAL, p_name, p_version, p_version_label, p_depends_on
                  );
   END;

   PROCEDURE set_component (
      p_name            xlib_components.comp_name%TYPE,
      p_version         xlib_components.comp_version%TYPE,
      p_version_label   xlib_components.comp_version_label%TYPE DEFAULT NULL,
      p_depends_on      xlib_components.comp_depends_on%TYPE DEFAULT NULL
   )
   IS
   BEGIN
      INSERT INTO xlib_components
                  (comp_id, comp_name, comp_version, comp_version_label, comp_depends_on
                  )
           VALUES (xlib_seq.NEXTVAL, p_name, p_version, p_version_label, p_depends_on
                  );
   EXCEPTION
      WHEN DUP_VAL_ON_INDEX
      THEN
         UPDATE xlib_components
            SET comp_version = p_version,
                comp_version_label = p_version_label,
                comp_depends_on = p_depends_on
          WHERE comp_name = p_name;

         IF SQL%ROWCOUNT = 0
         THEN
            raise_application_error (-20006,
                                     'component ' || p_name || ' not found'
                                    );
         END IF;
   END;

   PROCEDURE delete_component (p_name IN xlib_components.comp_name%TYPE)
   IS
   BEGIN
      -- delete component
      DELETE FROM xlib_components
            WHERE comp_name = p_name;

      IF SQL%ROWCOUNT = 0
      THEN
         raise_application_error (-20001,
                                  'Component ' || p_name || ' not found'
                                 );
      END IF;
   END;

   FUNCTION split_string (p_str IN VARCHAR2, p_sep IN VARCHAR2 DEFAULT ',')
      RETURN vc2_arr_t
   AS
      l_string      VARCHAR2 (32767) := p_str || p_sep;
      l_sep_index   PLS_INTEGER;
      l_index       PLS_INTEGER      := 1;
      l_tab         vc2_arr_t;
   BEGIN
      -- assertions
      IF LENGTH (p_sep) != 1
      THEN
         raise_application_error
                        (-20004,
                         'wrong separator format, must be only one character'
                        );
      END IF;

      LOOP
         l_sep_index := INSTR (l_string, p_sep, l_index);
         EXIT WHEN l_sep_index = 0;
         l_tab (l_tab.COUNT) :=
                            SUBSTR (l_string, l_index, l_sep_index - l_index);
         l_index := l_sep_index + 1;
      END LOOP;

      RETURN l_tab;
   END;



   FUNCTION get_version (p_name IN xlib_components.comp_name%TYPE)
      RETURN xlib_components.comp_version%TYPE
   IS
      l_version   xlib_components.comp_version%TYPE;
   BEGIN
      SELECT comp_version
        INTO l_version
        FROM xlib_components
       WHERE comp_name = p_name;

      RETURN l_version;
   END;

   PROCEDURE assert_version_format (p_version IN VARCHAR2)
   IS
      l_tab   vc2_arr_t;
      l_num   NUMBER;
   BEGIN
      -- '.' at the beginning or end of the version?
      IF    SUBSTR (p_version, 1, 1) = '.'
         OR SUBSTR (p_version, LENGTH (p_version), 1) = '.'
         OR INSTR (p_version, ' ') > 0
      THEN
         raise_application_error (-20002, 'wrong version format');
      END IF;

      l_tab := split_string (p_version, '.');

      FOR i IN 0 .. l_tab.COUNT - 1
      LOOP
         l_num := TO_NUMBER (l_tab (i));
      END LOOP;
   EXCEPTION
      WHEN OTHERS
      THEN
         IF SQLCODE = -6502   /* numeric or value error */
         THEN
            raise_application_error (-20005,
                                     'wrong version format, no numbers.'
                                    );
         ELSE
            RAISE;
         END IF;
   END;

   FUNCTION make_version_string (p_version IN VARCHAR2)
      RETURN VARCHAR2
   IS
      l_num_dots   NUMBER;
      l_tab        vc2_arr_t;
      l_str        VARCHAR2 (32767 CHAR);
      l_comp       VARCHAR2 (50 CHAR);
   BEGIN
      -- assertions
      assert_version_format (p_version => p_version);
      l_tab := split_string (p_version, '.');

      FOR i IN 1 .. c_num_version_components
      LOOP
         IF l_tab.EXISTS (i - 1)
         THEN
            l_comp :=
                     TO_CHAR (TO_NUMBER (NVL (l_tab (i - 1), '0')), 'FM0000');
         ELSE
            l_comp := '0000';
         END IF;

         IF l_str IS NULL
         THEN
            l_str := l_comp;
         ELSE
            l_str := l_str || '.' || l_comp;
         END IF;
      END LOOP;

      RETURN l_str;
   END;

   PROCEDURE verify_required_component (
      p_comp_name          IN   VARCHAR2,
      p_comp_version_min   IN   VARCHAR2
   )
   IS
      l_current_version   VARCHAR2 (50);
   BEGIN
      l_current_version := xlib_component.get_version (p_name      => p_comp_name);

      IF make_version_string (l_current_version)
            >= make_version_string (p_comp_version_min)
      THEN
         NULL;   -- ok
      ELSE
         raise_application_error
                           (-20020,
                               'this upgrade requires '||p_comp_name||' in version '
                            || p_comp_version_min
                            || ' or higher, not version '
                            || l_current_version
                           );
      END IF;
   END;
END xlib_component; 
/
 CREATE OR REPLACE PACKAGE  "XLIB_CONF" 
AS
/*==========================================================================
  $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $

  Purpose  : XLIB_CONF package

  $LastChangedDate: 2015-05-29 17:08:21 +0200 (Fri, 29 May 2015) $
  $LastChangedBy: dietmar.aust $

  Date        Author          Comment
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  15.02.2009  D. Aust         added param p_conf_comment

==========================================================================*/

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION get_value (
      p_conf_key   IN   VARCHAR2,
      p_app_ctx    IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain     IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN VARCHAR2;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION v (
      p_conf_key   IN   VARCHAR2,
      p_app_ctx    IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain     IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN VARCHAR2;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION nv (
      p_conf_key     IN   VARCHAR2,
      p_num_format   IN   VARCHAR2 DEFAULT NULL,
      p_app_ctx      IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain       IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN NUMBER;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION dv (
      p_conf_key      IN   VARCHAR2,
      p_date_format   IN   VARCHAR2 DEFAULT NULL,
      p_app_ctx       IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain        IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN DATE;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   PROCEDURE set_value (
      p_conf_key     IN   VARCHAR2,
      p_conf_value   IN   VARCHAR2,
      p_app_ctx      IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain       IN   VARCHAR2 DEFAULT 'GLOBAL',
      p_comment      in   varchar2 default null
   );

----------------------------------------------------------------------------
-- deletes a conf key from the table xlib_conf_values
--
-- Exceptions:
--   no_data_found (conf_key not found)
----------------------------------------------------------------------------
   PROCEDURE remove_conf_key (
      p_conf_key   IN   VARCHAR2,
      p_app_ctx    IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain     IN   VARCHAR2 DEFAULT 'GLOBAL'
   );
END; 
/
CREATE OR REPLACE PACKAGE BODY  "XLIB_CONF" 
AS

/******************************************************************************
   FILE  :  $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $
******************************************************************************/


----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION get_value (
      p_conf_key   IN   VARCHAR2,
      p_app_ctx    IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain     IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN VARCHAR2
   IS
      l_value   xlib_conf_values.conf_value%TYPE;
   BEGIN
      SELECT conf_value
        INTO l_value
        FROM xlib_conf_values
       WHERE conf_key = p_conf_key
         AND conf_app_ctx = p_app_ctx
         AND conf_domain = p_domain;

      RETURN l_value;
   EXCEPTION
      WHEN NO_DATA_FOUND
      THEN
         RETURN NULL;
   END;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION v (
      p_conf_key   IN   VARCHAR2,
      p_app_ctx    IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain     IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN get_value (p_conf_key      => p_conf_key,
                        p_app_ctx       => p_app_ctx,
                        p_domain        => p_domain
                       );
   END;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION nv (
      p_conf_key     IN   VARCHAR2,
      p_num_format   IN   VARCHAR2 DEFAULT NULL,
      p_app_ctx      IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain       IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN NUMBER
   IS
   BEGIN
      IF p_num_format IS NULL
      THEN
         RETURN TO_NUMBER (get_value (p_conf_key      => p_conf_key,
                                      p_app_ctx       => p_app_ctx,
                                      p_domain        => p_domain
                                     )
                          );
      ELSE
         RETURN TO_NUMBER (get_value (p_conf_key      => p_conf_key,
                                      p_app_ctx       => p_app_ctx,
                                      p_domain        => p_domain
                                     ),
                           p_num_format
                          );
      END IF;
   END;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   FUNCTION dv (
      p_conf_key      IN   VARCHAR2,
      p_date_format   IN   VARCHAR2 DEFAULT NULL,
      p_app_ctx       IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain        IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
      RETURN DATE
   IS
   BEGIN
      IF p_date_format IS NULL
      THEN
         RETURN TO_DATE (get_value (p_conf_key      => p_conf_key,
                                    p_app_ctx       => p_app_ctx,
                                    p_domain        => p_domain
                                   )
                        );
      ELSE
         RETURN TO_DATE (get_value (p_conf_key      => p_conf_key,
                                    p_app_ctx       => p_app_ctx,
                                    p_domain        => p_domain
                                   ),
                         p_date_format
                        );
      END IF;
   END;

----------------------------------------------------------------------------
--
----------------------------------------------------------------------------
   PROCEDURE set_value (
      p_conf_key     IN   VARCHAR2,
      p_conf_value   IN   VARCHAR2,
      p_app_ctx      IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain       IN   VARCHAR2 DEFAULT 'GLOBAL',
      p_comment      in   varchar2 default null
   )
   IS
   BEGIN
      -- update key
      UPDATE xlib_conf_values
         SET conf_value = p_conf_value
       WHERE conf_key = p_conf_key
         AND conf_app_ctx = p_app_ctx
         AND conf_domain = p_domain;

      -- key not found, create key
      IF SQL%ROWCOUNT = 0
      THEN
         INSERT INTO xlib_conf_values
                     (conf_key, conf_value, conf_app_ctx, conf_domain, conf_comment
                     )
              VALUES (p_conf_key, p_conf_value, p_app_ctx, p_domain,p_comment
                     );
      END IF;
   END;

----------------------------------------------------------------------------
-- deletes a conf key from the table xlib_conf_values
----------------------------------------------------------------------------
   PROCEDURE remove_conf_key (
      p_conf_key   IN   VARCHAR2,
      p_app_ctx    IN   VARCHAR2 DEFAULT xlib_context.get_application_context,
      p_domain     IN   VARCHAR2 DEFAULT 'GLOBAL'
   )
   IS
   BEGIN
      DELETE FROM xlib_conf_values
            WHERE conf_key = p_conf_key
              AND conf_app_ctx = p_app_ctx
              AND conf_domain = p_domain;

      IF SQL%ROWCOUNT = 0
      THEN
         RAISE NO_DATA_FOUND;
      END IF;
   END;
END; 
/
 CREATE OR REPLACE PACKAGE  "XLIB_CONTEXT" 
AS
   /*=========================================================================
     $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $

     Purpose  : xlib context

     $LastChangedDate: 2015-05-29 17:08:21 +0200 (Fri, 29 May 2015) $
     $LastChangedBy: dietmar.aust $

     Date        Author          Comment
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     31.01.2009  D. Aust          initial creation
   =========================================================================*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Multi - application capabilities
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION get_application_context
      RETURN VARCHAR2;

   PROCEDURE set_application_context (p_app_ctx IN VARCHAR2);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Session / User information
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION get_session_user
      RETURN VARCHAR2;

   FUNCTION get_parsing_schema
      RETURN VARCHAR2;

   FUNCTION get_app_user
      RETURN VARCHAR2;

   FUNCTION get_user
      RETURN VARCHAR2;

   FUNCTION is_public_user return BOOLEAN;

      /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * is the current user authenticated to the workspace as a developer
 * or administrator?
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION is_run_in_builder return boolean;

   /*
     checks, whether a build option is activated
   */
   FUNCTION is_build_option_active (p_build_option IN VARCHAR2)
      RETURN BOOLEAN
;

END; 
/
CREATE OR REPLACE PACKAGE BODY  "XLIB_CONTEXT" 
AS
   m_application_context   VARCHAR2 (50 CHAR);
   m_client_id             NUMBER;

--   m_owner_schema          VARCHAR2 (30 CHAR);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Multi - application capabilities
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION get_application_context
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN m_application_context;
   END;

   PROCEDURE set_application_context (p_app_ctx IN VARCHAR2)
   IS
   BEGIN
      m_application_context := p_app_ctx;
   END;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Session / User information
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION get_session_user
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN SYS_CONTEXT ('userenv', 'session_user');
   END;

   FUNCTION get_parsing_schema
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN SYS_CONTEXT ('userenv', 'current_user');
   END;

   FUNCTION get_app_user
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN v ('APP_USER');
   END;

   FUNCTION get_user
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN NVL (v ('APP_USER'), SYS_CONTEXT ('userenv', 'current_user'));
   END;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * is the current user authenticated to the workspace as a developer
 * or administrator?
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION is_run_in_builder return boolean
   is
   BEGIN
     return apex_application.g_edit_cookie_session_id is not null;
   END;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * is the current user authenticated or not?
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
   FUNCTION is_public_user return BOOLEAN
   is
     l_is_public boolean := false;
     l_app_user varchar2(500) := v('APP_USER');
   begin
--     xlog('is_public_user', 'app_user:#'||v('APP_USER')||'#');
     if (l_app_user is null or l_app_user in ('ANONYMOUS', 'HTMLDB_PUBLIC_USER', 'APEX_PUBLIC_USER', 'nobody')) then
       l_is_public := true;
     else
       l_is_public := false;
     end if;

--     xlog('is_public_user', 'app_user:#'||v('APP_USER')||'# = '|| owa_util.ite(l_is_public = true, 'true', 'false'));

     return l_is_public;

   end;

   /*
     checks, whether a build option is activated
   */
   FUNCTION is_build_option_active (p_build_option IN VARCHAR2)
      RETURN BOOLEAN
   IS
      l_c   CHAR (1);
   BEGIN
      SELECT '1'
        INTO l_c
        FROM DUAL
       WHERE EXISTS (
                SELECT build_option_status
                  FROM apex_application_build_options
                 WHERE application_id = v ('APP_ID')
                   AND build_option_name = p_build_option
                   AND build_option_status = 'Include');

      RETURN TRUE;
   EXCEPTION
      WHEN NO_DATA_FOUND
      THEN
         RETURN FALSE;
   END;


-- init
BEGIN
   m_application_context := 'GLOBAL';
   
END; 
/
 CREATE OR REPLACE PACKAGE  "XLIB_LOG" 
IS
/*=========================================================================
  $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $

  Purpose  : Application Logging

  License  : Copyright (c) 2010 Dietmar Aust (opal-consulting.de)
             Licensed under a BSD style license (license.txt)
             http://www.opal-consulting.de/pls/apex/f?p=20090928:14

  $LastChangedDate: 2015-05-29 17:08:21 +0200 (Fri, 29 May 2015) $
  $LastChangedBy: dietmar.aust $

  Date        Author          Comment
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  06.01.2010  D. Aust         Initial creation

=========================================================================*/

PROCEDURE m (
      p_module      IN   VARCHAR2,
      p_msg         IN   VARCHAR2,
      p_type    IN   VARCHAR2 DEFAULT 'DEBUG',
      p_level        PLS_INTEGER DEFAULT 15
   );
END; 
/
CREATE OR REPLACE PACKAGE BODY  "XLIB_LOG" 
IS
/*=========================================================================
   FILE  :  $Id: om_objects.sql 633 2015-05-29 15:08:21Z dietmar.aust $
=========================================================================*/

   PROCEDURE m (
      p_module      IN   VARCHAR2,
      p_msg         IN   VARCHAR2,
      p_type    IN   VARCHAR2 DEFAULT 'DEBUG',
      p_level   IN   PLS_INTEGER DEFAULT 15
   )
   IS
      PRAGMA AUTONOMOUS_TRANSACTION;
   BEGIN
      INSERT INTO xlib_logs
                  (log_module, log_msg, log_type, log_level, log_created_on, log_created_by
                  )
           VALUES (p_module, p_msg, p_type, p_level, sysdate, nvl(v('APP_USER'), user)
                  );
      COMMIT;
   END;
END; 
/
 

CREATE OR REPLACE PROCEDURE  "XLOG" (
   p_module   IN   VARCHAR2,
   p_msg      IN   VARCHAR2,
   p_type     IN   VARCHAR2 DEFAULT 'DEBUG',
   p_level         PLS_INTEGER DEFAULT 15
)
IS
BEGIN
   xlib_log.m (p_module      => p_module,
                       p_msg         => p_msg,
                       p_type        => p_type,
                       p_level       => p_level
                      );
END xlog; 
/
 

 CREATE SEQUENCE   "XLIB_LOG_SEQ"  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE
/
 CREATE SEQUENCE   "XLIB_SEQ"  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 347 CACHE 20 NOORDER  NOCYCLE
/

Rem No synonym found to generate DDL.

CREATE OR REPLACE TRIGGER  "OM_BP_ADDRESSES_BIU_TRG" 
BEFORE INSERT OR UPDATE
ON OM_BP_ADDRESSES 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.ADR_updated_on := SYSDATE;
   :new.ADR_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN 
      IF :NEW.ADR_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.ADR_id
           FROM DUAL;
      END IF;
      :new.ADR_created_on  := :new.ADR_updated_on;
      :new.ADR_created_by := :new.ADR_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_BP_ADDRESSES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_BP_ADR_TYPES_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_BP_ADR_TYPES
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.ADRT_updated_on := SYSDATE;
   :new.ADRT_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN 
    
      :new.ADRT_created_on  := :new.ADRT_updated_on;
      :new.ADRT_created_by := :new.ADRT_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_BP_ADR_TYPES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_BP_COD_TYPES_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON om_bp_cod_types
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :NEW.codt_updated_on := SYSDATE;
   :NEW.codt_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING
   THEN
      :NEW.codt_created_on := :NEW.codt_updated_on;
      :NEW.codt_created_by := :NEW.codt_updated_by;
      :NEW.codt_valid_from := SYSDATE;
      :NEW.codt_valid_until := TRUNC (SYSDATE + 10000, 'YYYY');
   END IF;
END; 
/
ALTER TRIGGER  "OM_BP_COD_TYPES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_BP_CONTACTS_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_BP_CONTACTS
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.CON_updated_on := SYSDATE;
   :new.CON_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN 
      IF :NEW.CON_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.CON_id
           FROM DUAL;
      END IF;
      :new.CON_created_on  := :new.CON_updated_on;
      :new.CON_created_by := :new.CON_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_BP_CONTACTS_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_BP_CON_DETAILS_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_BP_CON_DETAILS
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.COD_updated_on := SYSDATE;
   :new.COD_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN
      IF :NEW.COD_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.COD_id
           FROM DUAL;
      END IF;
      :new.COD_created_on  := :new.COD_updated_on;
      :new.COD_created_by := :new.COD_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_BP_CON_DETAILS_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_BUSINESS_PARTNERS_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_BUSINESS_PARTNERS
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.BP_updated_on := SYSDATE;
   :new.BP_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN 
      IF :NEW.BP_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.BP_id
           FROM DUAL;
      END IF;
      :new.BP_created_on  := :new.BP_updated_on;
      :new.BP_created_by := :new.BP_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_BUSINESS_PARTNERS_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_ORDERS_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_ORDERS
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.ORD_updated_on := SYSDATE;
   :new.ORD_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN
      IF :NEW.ORD_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.ORD_id
           FROM DUAL;
      END IF;
      :new.ORD_created_on  := :new.ORD_updated_on;
      :new.ORD_created_by := :new.ORD_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_ORDERS_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_ORD_ITEMS_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_ORD_ITEMS    REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.OIT_updated_on := SYSDATE;
   :new.OIT_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN
      IF :NEW.OIT_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.OIT_id
           FROM DUAL;
      END IF;
      :new.OIT_created_on  := :new.OIT_updated_on;
      :new.OIT_created_by := :new.OIT_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_ORD_ITEMS_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_PRODUCTS_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON OM_PRODUCTS    REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.PROD_updated_on := SYSDATE;
   :new.PROD_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN
      IF :NEW.PROD_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.PROD_id
           FROM DUAL;
      END IF;
      :new.PROD_created_on  := :new.PROD_updated_on;
      :new.PROD_created_by := :new.PROD_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_PRODUCTS_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_PROD_CATEGORIES_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON om_prod_categories
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :NEW.pcat_updated_on := SYSDATE;
   :NEW.pcat_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING
   THEN
      IF :NEW.pcat_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.pcat_id
           FROM DUAL;
      END IF;

      :NEW.pcat_created_on := :NEW.pcat_updated_on;
      :NEW.pcat_created_by := :NEW.pcat_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_PROD_CATEGORIES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_PROD_PRICES_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON om_prod_prices
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :NEW.pri_updated_on := SYSDATE;
   :NEW.pri_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING
   THEN
      IF :NEW.pri_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.pri_id
           FROM DUAL;
      END IF;

      :NEW.pri_created_on := :NEW.pri_updated_on;
      :NEW.pri_created_by := :NEW.pri_updated_by;
      :NEW.pri_valid_from := SYSDATE;
      :NEW.pri_valid_until := TRUNC (SYSDATE + 10000, 'YYYY');
   END IF;
END; 
/
ALTER TRIGGER  "OM_PROD_PRICES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "OM_PROD_TYPES_BIU_TRG" 
BEFORE INSERT OR UPDATE
ON OM_PROD_TYPES 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.PT_updated_on := SYSDATE;
   :new.PT_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN
      :new.PT_created_on  := :new.PT_updated_on;
      :new.PT_created_by := :new.PT_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "OM_PROD_TYPES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "XLIB_CMS_FILES_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON XLIB_CMS_FILES
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   -- INSERTING OR UPDATING
   :new.FIL_updated_on := SYSDATE;
   :new.FIL_updated_by := NVL (v ('APP_USER'), USER);

   IF INSERTING THEN
      IF :NEW.FIL_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.FIL_id
           FROM DUAL;
      END IF;
      :new.FIL_created_on  := :new.FIL_updated_on;
      :new.FIL_created_by := :new.FIL_updated_by;
   END IF;
END; 
/
ALTER TRIGGER  "XLIB_CMS_FILES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "XLIB_CMS_FILES_BI_TRG" 
   BEFORE INSERT
   ON "XLIB_CMS_FILES"
   FOR EACH ROW
BEGIN
   IF :NEW.fil_id IS NULL
   THEN
      SELECT xlib_seq.NEXTVAL
        INTO :NEW.fil_id
        FROM DUAL;
   END IF;

   :NEW.fil_created_on    := SYSDATE;
   :NEW.fil_created_by    := NVL (v ('APP_USER'), USER);
END; 
/
ALTER TRIGGER  "XLIB_CMS_FILES_BI_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "XLIB_CONF_VALUES_BIU_TRG" 
   BEFORE INSERT OR UPDATE
   ON xlib_conf_values
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
DECLARE
BEGIN
      IF :NEW.conf_id IS NULL
      THEN
         SELECT xlib_seq.NEXTVAL
           INTO :NEW.conf_id
           FROM DUAL;
      END IF;

      :new.conf_app_ctx := xlib_context.get_application_context;
END; 
/
ALTER TRIGGER  "XLIB_CONF_VALUES_BIU_TRG" ENABLE
/
CREATE OR REPLACE TRIGGER  "XLIB_LOGS_BI_TRG" 
   BEFORE INSERT
   ON XLIB_LOGS    REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
  IF :NEW.log_id IS NULL
  THEN
     SELECT XLIB_LOG_SEQ.NEXTVAL
       INTO :NEW.log_id
       FROM DUAL;
  END IF;
END; 
/
ALTER TRIGGER  "XLIB_LOGS_BI_TRG" ENABLE
/

CREATE OR REPLACE FORCE VIEW  "OM_CUSTOMERS_V" ("BP_ID", "BP_TITLE", "BP_SAP_NO", "BP_IS_CUSTOMER", "BP_IS_SUPPLIER", "BP_IS_OWNER", "BP_CREATED_BY", "BP_CREATED_ON", "BP_UPDATED_BY", "BP_UPDATED_ON", "BP_UPDATED_DESC", "BP_DESC") AS 
  SELECT "BP_ID","BP_TITLE","BP_SAP_NO","BP_IS_CUSTOMER","BP_IS_SUPPLIER","BP_IS_OWNER","BP_CREATED_BY","BP_CREATED_ON","BP_UPDATED_BY","BP_UPDATED_ON","BP_UPDATED_DESC","BP_DESC"
  FROM om_business_partners
 WHERE bp_is_customer = 1
/
CREATE OR REPLACE FORCE VIEW  "OM_ORD_ITEMS_V" ("OIT_ORD_ID", "OIT_PROD_ID", "PCAT_TITLE", "PROD_TITLE", "OIT_QUANTITY", "OIT_PRICE", "OIT_DISCOUNT_PERCENT", "TOTAL_TURNOVER", "ORD_CREATED_ON") AS 
  SELECT oit_ord_id, oit_prod_id, pcat_title, prod_title, oit_quantity,
          oit_price, oit_discount_percent,
          ROUND (  (oit_quantity * oit_price)
                 * (100 - NVL (oit_discount_percent, 0))
                 / 100,
                 2
                ) total_turnover,
          ord_created_on
     FROM om_ord_items, om_products, om_orders, om_prod_categories
    WHERE om_ord_items.oit_prod_id = om_products.prod_id
      AND om_ord_items.oit_ord_id = om_orders.ord_id
      AND om_products.prod_pcat_id_parent = om_prod_categories.pcat_id
/
CREATE OR REPLACE FORCE VIEW  "OM_PROD_CATEGORIES_RL_V" ("PROD_ID", "PCAT_ID", "PCAT_CODE", "PCAT_TITLE", "PATH", "PROD_PT_CODE", "PROD_TITLE") AS 
  SELECT prod.prod_id,
          pcat.pcat_id,
          pcat.pcat_code,
          pcat.pcat_title,
          pcat.PATH,
          prod.prod_pt_code,
          prod.PROD_TITLE
     FROM om_prod_categories_v pcat, om_products prod
    WHERE pcat.pcat_id(+) = prod.prod_pcat_id
/
CREATE OR REPLACE FORCE VIEW  "OM_PROD_CATEGORIES_V" ("PCAT_ID", "PCAT_CODE", "PCAT_TITLE", "PATH_LEVEL", "PATH", "PCAT_PARENT_ID", "PCAT_CREATED_BY", "PCAT_CREATED_ON", "PCAT_UPDATED_BY", "PCAT_UPDATED_ON", "PCAT_UPDATED_DESC") AS 
  SELECT     pcat_id, pcat_code, pcat_title, LEVEL path_level,
              SUBSTR (SYS_CONNECT_BY_PATH (pcat_title, ' > '), 4) PATH,
              pcat_parent_id, pcat_created_by, pcat_created_on,
              pcat_updated_by, pcat_updated_on, pcat_updated_desc
         FROM om_prod_categories
   CONNECT BY PRIOR pcat_id = pcat_parent_id
   START WITH pcat_parent_id IS NULL
/
CREATE OR REPLACE FORCE VIEW  "OM_SUPPLIERS_V" ("BP_ID", "BP_TITLE", "BP_SAP_NO", "BP_IS_CUSTOMER", "BP_IS_SUPPLIER", "BP_IS_OWNER", "BP_CREATED_BY", "BP_CREATED_ON", "BP_UPDATED_BY", "BP_UPDATED_ON", "BP_UPDATED_DESC", "BP_DESC") AS 
  SELECT "BP_ID","BP_TITLE","BP_SAP_NO","BP_IS_CUSTOMER","BP_IS_SUPPLIER","BP_IS_OWNER","BP_CREATED_BY","BP_CREATED_ON","BP_UPDATED_BY","BP_UPDATED_ON","BP_UPDATED_DESC","BP_DESC"
  FROM om_business_partners
 WHERE bp_is_supplier = 1
/

---------------------------------
-- neue View für die Produkte
---------------------------------

CREATE OR REPLACE FORCE VIEW OM_PRODUCTS_RL_V
AS
   SELECT prod.prod_id,
          pcat.pcat_id,
          pcat.pcat_code,
          pcat.pcat_title,
          pcat.PATH,
          prod.prod_pt_code,
          prod.PROD_TITLE,
          fil.fil_blob_content image_blob
     FROM om_prod_categories_v pcat
          INNER JOIN om_products prod
             ON (pcat.pcat_id = prod.prod_pcat_id)
          left  OUTER JOIN xlib_cms_files fil
             ON (PROD.PROD_IMAGE_FIL_ID = FIL.FIL_ID);

			 
			 